/* crtcats.sql  */
/* Created by Laurence D. Finston (LDF) Undated.  */

/*

$Id: crtcats.sql,v 1.1 2006/10/23 15:49:32 ldf Exp $

* (1) Copyright and License.

This file is part of the IWF Metadata Harvester, a package for metadata harvesting.  
Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH

The author is Laurence D. Finston.                                                   

The IWF Metadata Harvester is free software; you can redistribute it and/or modify   
it under the terms of the GNU General Public License as published by                 
the Free Software Foundation; either version 2 of the License, or                    
(at your option) any later version.                                                  

The IWF Metadata Harvester is distributed in the hope that it will be useful,        
but WITHOUT ANY WARRANTY; without even the implied warranty of                       
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                             
GNU General Public License for more details.                                         

You should have received a copy of the GNU General Public License                    
along with the IWF Metadata Harvester; if not, write to the Free Software            
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA                   

The IWF Metadata Harvester is available for downloading from the                     
following FTP server:                                                                
ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/

Please send bug reports to lfinsto1@gwdg.de                                         

The author can be contacted at:                                                      

Laurence D. Finston 
Kreuzbergring 41    
D-37075 Goettingen  
Germany             

lfinsto1@gwdg.de 
s246794@stud.uni-goettingen.de                        
*/

/* 
LOG

LDF 2006.10.23.
Renamed this file:
Old name:  `create_catalogues.sql'
New name:  `crtcats.sql'

ENDLOG
*/

create proc create_catalogues
as
exec sp_fulltext_database enable

/* Contributors  */

exec sp_fulltext_catalog 'Contributors_Catalogue', 'drop'
exec sp_fulltext_catalog 'Contributors_Catalogue', 'create'

EXEC sp_fulltext_table 'Contributors', 'create', 
     'Contributors_Catalogue', 'PK_Contributors'

EXEC sp_fulltext_column 'Contributors', 'dc_contributor', 'add'


EXEC sp_fulltext_table 'Contributors','activate'

EXEC sp_fulltext_catalog 'Contributors_Catalogue', 'start_full'

/* Creators  */

exec sp_fulltext_catalog 'Creators_Catalogue', 'drop'
exec sp_fulltext_catalog 'Creators_Catalogue', 'create'

EXEC sp_fulltext_table 'Creators', 'create', 
     'Creators_Catalogue', 'PK_Creators'

EXEC sp_fulltext_column 'Creators', 'dc_creator', 'add'

EXEC sp_fulltext_table 'Creators','activate'

EXEC sp_fulltext_catalog 'Creators_Catalogue', 'start_full'


/* Descriptions.  */

exec sp_fulltext_catalog 'Descriptions_Catalogue', 'drop'
exec sp_fulltext_catalog 'Descriptions_Catalogue', 'create'

EXEC sp_fulltext_table 'Descriptions', 'create', 
     'Descriptions_Catalogue', 'PK_Descriptions'

EXEC sp_fulltext_column 'Descriptions', 'dc_description', 'add'

EXEC sp_fulltext_table 'Descriptions','activate'

exec sp_fulltext_catalog 'Descriptions_Catalogue', 'start_full'

/* Identifiers.  */

exec sp_fulltext_catalog 'Identifiers_Catalogue', 'drop'
exec sp_fulltext_catalog 'Identifiers_Catalogue', 'create'

EXEC sp_fulltext_table 'Identifiers', 'create', 
     'Identifiers_Catalogue', 'PK_Identifiers'

EXEC sp_fulltext_column 'Identifiers', 'dc_identifier', 'add'

EXEC sp_fulltext_table 'Identifiers','activate'

exec sp_fulltext_catalog 'Identifiers_Catalogue', 'start_full'

/* Languages.  */

exec sp_fulltext_catalog 'Languages_Catalogue', 'drop'
exec sp_fulltext_catalog 'Languages_Catalogue', 'create'

EXEC sp_fulltext_table 'Languages', 'create', 
     'Languages_Catalogue', 'PK_Languages'

EXEC sp_fulltext_column 'Languages', 'dc_language', 'add'

EXEC sp_fulltext_table 'Languages','activate'

exec sp_fulltext_catalog 'Languages_Catalogue', 'start_full'


/* Publishers.  */

exec sp_fulltext_catalog 'Publishers_Catalogue', 'drop'
exec sp_fulltext_catalog 'Publishers_Catalogue', 'create'

EXEC sp_fulltext_table 'Publishers', 'create', 
     'Publishers_Catalogue', 'PK_Publishers'

EXEC sp_fulltext_column 'Publishers', 'dc_publisher', 'add'

EXEC sp_fulltext_table 'Publishers','activate'

exec sp_fulltext_catalog 'Publishers_Catalogue', 'start_full'


/* Rights.  */

exec sp_fulltext_catalog 'Rights_Catalogue', 'drop'
exec sp_fulltext_catalog 'Rights_Catalogue', 'create'

EXEC sp_fulltext_table 'Rights', 'create', 
     'Rights_Catalogue', 'PK_Rights'

EXEC sp_fulltext_column 'Rights', 'dc_rights', 'add'

EXEC sp_fulltext_table 'Rights','activate'

exec sp_fulltext_catalog 'Rights_Catalogue', 'start_full'

/* Subjects  */

exec sp_fulltext_catalog 'Subjects_Catalogue', 'drop'
exec sp_fulltext_catalog 'Subjects_Catalogue', 'create'

EXEC sp_fulltext_table 'Subjects', 'create', 
     'Subjects_Catalogue', 'PK_Subjects'

EXEC sp_fulltext_column 'Subjects', 'dc_Subject', 'add'

EXEC sp_fulltext_table 'Subjects','activate'

exec sp_fulltext_catalog 'Subjects_Catalogue', 'start_full'

/* Titles  */

exec sp_fulltext_catalog 'Titles_Catalogue', 'drop'
exec sp_fulltext_catalog 'Titles_Catalogue', 'create'

EXEC sp_fulltext_table 'Titles', 'create', 
     'Titles_Catalogue', 'PK_Titles'

EXEC sp_fulltext_column 'Titles', 'dc_title', 'add'

EXEC sp_fulltext_table 'Titles','activate'

exec sp_fulltext_catalog 'Titles_Catalogue', 'start_full'


/* Types  */

exec sp_fulltext_catalog 'Types_Catalogue', 'drop'
exec sp_fulltext_catalog 'Types_Catalogue', 'create'

EXEC sp_fulltext_table 'Types', 'create', 
     'Types_Catalogue', 'PK_Types'

EXEC sp_fulltext_column 'Types', 'dc_type', 'add'

EXEC sp_fulltext_table 'Types','activate'

exec sp_fulltext_catalog 'Types_Catalogue', 'start_full'
go

