/* crttabls.sql.  */
/* Created by Laurence D. Finston (LDF) 2006.05.12.  */

/*

$Id: crttabls.sql,v 1.3 2006/11/23 14:01:12 ldf Exp $

* (1) Copyright and License.

This file is part of the IWF Metadata Harvester, a package for metadata harvesting.  
Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH

The author is Laurence D. Finston.                                                   

The IWF Metadata Harvester is free software; you can redistribute it and/or modify   
it under the terms of the GNU General Public License as published by                 
the Free Software Foundation; either version 2 of the License, or                    
(at your option) any later version.                                                  

The IWF Metadata Harvester is distributed in the hope that it will be useful,        
but WITHOUT ANY WARRANTY; without even the implied warranty of                       
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                             
GNU General Public License for more details.                                         

You should have received a copy of the GNU General Public License                    
along with the IWF Metadata Harvester; if not, write to the Free Software            
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA                   

The IWF Metadata Harvester is available for downloading from the                     
following FTP server:                                                                
ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/

Please send bug reports to lfinsto1@gwdg.de                                         

The author can be contacted at:                                                      

Laurence D. Finston 
Kreuzbergring 41    
D-37075 Goettingen  
Germany             

lfinsto1@gwdg.de 
s246794@stud.uni-goettingen.de                        
*/

/* 
LOG

LDF 2006.10.23.
Renamed this file:
Old name:  `create_tables.sql'
New name:  `crttabls.sql'

ENDLOG
*/

/* * (1)  */

/* START HERE:  LDF 2006.11.20.  
   Add these tables and/or columns:

   Publishers:place
   Titles:dc_title_series

*/


/* * (1)  */


create proc create_tables
as


/* Records.  */

/* 
drop table Records_Subjects
drop table Subjects
drop table Titles
drop table Records
*/




-- drop table Sources
create table Sources
(
   source_id int identity (0, 1) not null,
   source_name varchar(128) not null default 'N/A',
   source_abbrev varchar(32) not null default 'N/A',
   source_address varchar (1024) not null default 'N/A',
   constraint PK_Sources primary key (source_id)
)


insert Sources
(source_name, source_abbrev, source_address)
values
('N/A', 'N/A', 'N/A')


insert Sources
(source_name, source_abbrev)
values
('Tbinger Internet Multimedia Servers', 'timms')

insert Sources
(source_name, source_abbrev)
values
('Digitale Bibliothek Thringen', 'DBT')





-- drop table Records
create table Records
(
record_id int identity not null,
header_identifier varchar(512) not null default 'N/A',
header_datestamp datetime not null,
header_status varchar(128) not null default 'normal',
dc_date datetime null,
source_id int references Sources(source_id) not null default 0 
constraint PK_Records primary key (record_id)
)

-- drop table Records_Temp
create table Records_Temp
(
   record_id int not null,
   header_identifier varchar(512) not null default 'N/A',
   header_datestamp datetime not null,
   header_status varchar(128) not null default 'normal',
   dc_date datetime null,
   source_id int not null
)

/* * (1) */

-- drop table Titles
create table Titles
(
title_id int identity not null,
record_id int references Records(record_id) not null,
dc_title varchar(512),
constraint PK_Titles primary key (title_id)
)



-- drop table Titles_Temp
create table Titles_Temp
(
title_id int not null,
record_id int  not null,
dc_title varchar(512)
)


/* * (1) */

-- drop table Subjects
create table Subjects
(
subject_id int identity not null,
dc_subject varchar(512) unique not null,
constraint PK_Subjects primary key (subject_id)
)

-- drop table Subjects_Temp
create table Subjects_Temp
(
subject_id int  not null,
dc_subject varchar(512) not null
)



/* * (1) */

-- drop table Records_Subjects
create table Records_Subjects
(
record_id int references Records(record_id) not null,
subject_id int references Subjects(subject_id) not null
)

/* * (1) Institutions.  */

-- drop table Institutions
create table Institutions
(
institution_id int identity (0,1) not null,
institution_name varchar(1024) not null default 'N/A',
institution_abbrev varchar(256) not null default 'N/A',
constraint PK_Institutions primary key (institution_id)
)

insert Institutions
(institution_name, institution_abbrev)
values
('N/A', 'N/A')

-- select * from Institutions

/* * (1) Persons.  */

-- drop table Persons
create table Persons
(
person_id int identity (0,1) not null,
person_name varchar(1024) not null default 'N/A',
person_abbrev varchar(256) not null default 'N/A',
constraint PK_Persons primary key (person_id)
)

insert Persons
(person_name, person_abbrev)
values
('N/A', 'N/A')

-- select * from Persons


/* * (1) Companies.  */

-- drop table Companies
create table Companies
(
company_id int  identity (0,1) not null,
company_name varchar(1024) not null default 'N/A',
company_abbrev varchar(256) not null default 'N/A',
constraint PK_Companies primary key (company_id)
)

insert Companies
(company_name, company_abbrev)
values
('N/A', 'N/A')

-- select * from Companies

/* * (1) */

-- drop table Creators
-- select * from creators

-- drop table Creators
create table Creators
(
creator_id int identity (0, 1) not null,
dc_creator varchar(64) not null default 'N/A',
institution_id int references Institutions(institution_id) not null default 0,
person_id int references Persons(person_id) not null default 0,
constraint PK_Creators primary key (creator_id)
)

insert Creators
(institution_id, person_id)
values
(0, 0)

-- select * from Creators


/* Creators_Temp */

-- drop table Creators_Temp
create table Creators_Temp
(
creator_id int not null,
dc_creator varchar(64) not null default 'N/A',
institution_id int not null default 0,
person_id int not null default 0
)

/* * (1) records_creators */

-- select * from Records_Creators

-- drop table  Records_Creators
create table Records_Creators
(
record_id int references Records(record_id) not null,
creator_id int references Creators(creator_id) not null
)


/* * (1) Contributors */

-- drop table Contributors
-- select * from Contributors

-- drop table Contributors
create table Contributors
(
contributor_id int identity not null,
dc_contributor varchar(512) not null default 'N/A',
institution_id int references Institutions(institution_id) not null default 0,
person_id int references Persons(person_id) not null default 0,
constraint PK_Contributors primary key (contributor_id)
)

-- select * from Records_Contributors
-- drop table Records_Contributors
create table Records_Contributors
(
record_id int references Records(record_id) not null,
contributor_id int references Contributors(contributor_id) not null
)

/* * (1) Contributors_Temp */

-- drop table Contributors_Temp
create table Contributors_Temp
(
contributor_id int  not null,
dc_contributor varchar(512) not null default 'N/A',
institution_id int not null default 0,
person_id int not null default 0
)


/* * (1) Descriptions */

-- drop table Descriptions
-- select * from Descriptions

-- drop table Descriptions
create table Descriptions
(
description_id int  identity not null,
record_id int references Records(record_id) not null,
dc_description varchar(2048) not null default 'N/A',
constraint PK_Descriptions primary key (description_id)
)

/* * (1) Descriptions_Temp */

-- drop table Descriptions_Temp
-- select * from Descriptions_Temp

-- drop table Descriptions_Temp
create table Descriptions_Temp
(
description_id int not null,
record_id int not null,
dc_description varchar(2048) not null default 'N/A',
)

/* * (1) publishers */

-- drop table Publishers
-- select * from Publishers

-- drop table Publishers
create table Publishers
(
publisher_id int  identity not null,
dc_publisher varchar(64) not null default 'N/A',
person_id int not null references Persons(person_id) default 0,
institution_id int not null references Institutions(institution_id) default 0,
company_id int not null references Companies(company_id) default 0,
constraint PK_Publishers primary key (publisher_id)
)

-- select * from Records_Publishers

-- drop table Records_Publishers
create table Records_Publishers
(
record_id int not null references Records(record_id),
publisher_id int not null references Publishers(publisher_id) default 0
)


/* Publishers_Temp  */

-- drop table Publishers_Temp
create table Publishers_Temp
(
publisher_id int not null,
dc_publisher varchar(64) not null default 'N/A',
person_id int not null  default 0,
institution_id int not null default 0,
company_id int not null default 0
)


/* * (1) Types */

-- drop table Types
create table Types
(
type_id int  identity (0,1) not null,
dc_type varchar(64) not null default 'N/A',
constraint PK_Types primary key (type_id)
)

insert Types
(dc_type)
values
('N/A')

-- select * from Types


/* * (1) Types_Temp */

-- drop table Types_Temp
create table Types_Temp
(
type_id int  not null,
dc_type varchar(64) not null default 'N/A'
)

/* ** (2) Records_Types */

-- select * from Records_Types

-- drop table Records_Types
create table Records_Types
(
record_id int not null references Records(record_id),
type_id int not null references Types(type_id) default 0
)


/* * (1) Rights */

-- drop table Rights
create table Rights
(
rights_id int  identity not null,
dc_rights varchar(1024) not null default 'N/A',
constraint PK_Rights primary key (rights_id)
)

/* * (1) Rights_Temp */

-- drop table Rights_Temp
create table Rights_Temp
(
rights_id int not null,
dc_rights varchar(1024) not null default 'N/A',
)


-- select * from Records_Rights

/* ** (2) Records_Rights */

-- drop table Records_Rights
create table Records_Rights
(
record_id int not null references Records(record_id),
rights_id int not null references Rights(rights_id),
)

/* * (1) Languages */

-- drop table Languages
create table Languages
(
language_id int identity not null,
dc_language varchar(64) not null default 'N/A',
constraint PK_Languages primary key (language_id)
)

/* * (1) Languages_Temp */

-- drop table Languages_Temp
create table Languages_Temp
(
language_id int  not null,
dc_language varchar(64) not null default 'N/A',
)

/* ** (2) Records_Languages */

-- select * from Records_Languages

-- drop table Records_Languages
create table Records_Languages
(
record_id int not null references Records(record_id),
language_id int not null references Languages(language_id),
)

/* * (1) Identifiers */

-- drop table Identifiers
create table Identifiers
(
identifier_id int  identity not null,
dc_identifier varchar(1024) not null default 'N/A',
constraint PK_Identifiers primary key (identifier_id)
)

/* * (1) Identifiers_Temp */

-- drop table Identifiers_Temp
create table Identifiers_Temp
(
identifier_id int  not null,
dc_identifier varchar(1024) not null default 'N/A',
)


-- select * from Records_Identifiers

/* ** (2) Records_Identifiers */

-- drop table Records_Identifiers
create table Records_Identifiers
(
record_id int not null references Records(record_id),
identifier_id int not null references Identifiers(identifier_id)
)


/* * (1) Temp_Ids */
-- drop table Temp_IDs
create table Temp_IDs
(
   temp_id int
)


/* * (1) Temp_Ids_1 */
-- drop table Temp_IDs_1
create table Temp_IDs_1
(
   temp_id int
)
go


/* 
Local Variables:
abbrev-mode:t
End:
*/