/* wrttabls.sql  */
/* Created by Laurence D. Finston (LDF) 2006.05.15.  */

/*

$Id: wrttabls.sql,v 1.1 2006/10/23 16:09:01 ldf Exp $

* (1) Copyright and License.

This file is part of the IWF Metadata Harvester, a package for metadata harvesting.  
Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH

The author is Laurence D. Finston.                                                   

The IWF Metadata Harvester is free software; you can redistribute it and/or modify   
it under the terms of the GNU General Public License as published by                 
the Free Software Foundation; either version 2 of the License, or                    
(at your option) any later version.                                                  

The IWF Metadata Harvester is distributed in the hope that it will be useful,        
but WITHOUT ANY WARRANTY; without even the implied warranty of                       
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                             
GNU General Public License for more details.                                         

You should have received a copy of the GNU General Public License                    
along with the IWF Metadata Harvester; if not, write to the Free Software            
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA                   

The IWF Metadata Harvester is available for downloading from the                     
following FTP server:                                                                
ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/

Please send bug reports to lfinsto1@gwdg.de                                         

The author can be contacted at:                                                      

Laurence D. Finston 
Kreuzbergring 41    
D-37075 Goettingen  
Germany             

lfinsto1@gwdg.de 
s246794@stud.uni-goettingen.de                        
*/

/* 
LOG

LDF 2006.10.23.
Renamed this file:
Old name:  `write_to_tables.sql'
New name:  `wrttabls.sql'

ENDLOG
*/

/* * (1)  */


/* TODO:  Look up XML schemas.  LDF 2006.05.15.

          Find out how to pass XML code from a Visual C++ program.    LDF 2006.05.15.
          Must process records in order to remove umlauts.

*/

/* * (1) Complete definition.  */

alter procedure write_to_tables
@source_number int,
@record_ctr bigint,
@XML_data ntext,
@namespace_data nvarchar(4000)
as

/* Source numbers.  They must correspond to the constants declared in |class CMetadataSource|
   in the file `MetadataSource.h'.  
   LDF 2006.07.06.  
*/

declare @TIMMS int
declare @DBT   int

set @TIMMS = 1
set @DBT   = 2

/* */

declare @testdoc int
declare @curr_record_id int
declare @temp_dc_date_str nvarchar(64)
declare @curr_subject_id int
declare @curr_creator_id int
declare @curr_contributor_id int
declare @curr_publisher_id int
declare @curr_type_id int
declare @curr_language_id int
declare @curr_rights_id int
declare @curr_identifier_id int
declare @temp_dc_creator varchar(512)
declare @temp_dc_contributor varchar(512)
declare @temp_dc_publisher varchar(512)
declare @temp_dc_type varchar(512)
declare @temp_dc_language varchar(64)
declare @temp_dc_rights varchar(1024)
declare @temp_dc_subject varchar(512)
declare @temp_dc_title varchar(512)
declare @temp_dc_description varchar(2048)
declare @temp_dc_identifier varchar(1024)
declare @curr_datestamp_str varchar(64)
declare @datestamp_str_len int
declare @new_datestamp_str varchar(64)
declare @status_ctr int
declare @status_str varchar(32)

declare @temp_ctr bigint
declare @contributor_ctr bigint
declare @creator_ctr bigint
declare @description_ctr bigint
declare @identifier_ctr bigint
declare @language_ctr bigint
declare @publisher_ctr bigint
declare @rights_ctr bigint
declare @subject_ctr bigint
declare @title_ctr bigint
declare @type_ctr bigint

/* *** (3) Prepare XML document.  */

exec sp_xml_preparedocument @testdoc output, @XML_data, @namespace_data


/* *** (3) Prevent duplicate records from being added.  */
/* ?? 
   It caused a "serious connection error" when I tried to use 
   |identifier_cursor| here, and then below.  I don't know why.  
   LDF 2006.06.29.
*/

declare id_cursor cursor for
select convert(varchar(512), [text]) 
   from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:identifier') 
where text is not null

open id_cursor

declare @temp_id varchar(512)

fetch next from id_cursor into @temp_id

while (@@fetch_status <> -1)
begin
   if exists (select * from identifiers where dc_identifier = @temp_id)
      begin
         close id_cursor
         deallocate id_cursor
         return
      end
   else
      fetch next from id_cursor into @temp_id
end

close id_cursor
deallocate id_cursor

/* *** (3) */


/* Add entry to `records' table with `header_identifier'.  */

/* Calculate `header_datestamp'.  */

select @curr_datestamp_str = header_datestamp from openxml(@testdoc, '/record')
with (header_datestamp  varchar(512) './header/datestamp')

select @curr_datestamp_str as 'curr_datestamp_str'

/* START HERE:  Add argument for source, or figure out way of deciding
                how to set @new_datestamp_str correctly.
                LDF 2006.07.05.  
*/ 

/* !! Changed for DBT.  This may not work for TIMMS!  Check.  */

if @source_number = @TIMMS
   set @datestamp_str_len = len(@curr_datestamp_str)
else if @source_number = @DBT
   set @datestamp_str_len = len(@curr_datestamp_str) + 1

select @datestamp_str_len

set @new_datestamp_str = substring(@curr_datestamp_str, 0, @datestamp_str_len)
select @new_datestamp_str

declare @curr_header_id varchar(512)
select @curr_header_id = header_identifier from openxml(@testdoc, '/record')
with (header_identifier varchar(512) './header/identifier')

/* ** (2) Handle `header_status' entry.  There should only be one.  */

select @status_ctr = [id] from openxml(@testdoc, '/record/header/')
where localname = 'status'

if (@status_ctr is not null)
   begin
      select @status_str = convert(varchar(32), [text]) from openxml(@testdoc, '/record/header')
         where parentid = @status_ctr
   end
else
   set @status_str = 'normal'

/* ** (2) Handle `dc:date' entry.  There should only be one.  */


select @temp_dc_date_str = convert(varchar(64), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:date') 

/* Insert new line in `records' with values for the fields
   `header_identifier', `header_datestamp', `header_status', and `dc_date'.  */

select top 1 @temp_ctr = record_id from Records order by record_id desc

if @temp_ctr is NULL
set @record_ctr = 1
else
set @record_ctr = @temp_ctr + 1

-- select @new_datestamp_str as 'new_datestamp_str'
-- select @temp_dc_date_str as 'temp_dc_date_str'

set @new_datestamp_str = replace(@new_datestamp_str, '_', '-')
set @temp_dc_date_str  = replace(@temp_dc_date_str, '_', '-')

declare @hyphen_index int


select @new_datestamp_str as 'new_datestamp_str before'
select @temp_dc_date_str as 'temp_dc_date_str before'

/* START HERE.  Kludge!  This replaces invalid datestamp strings, in a
                form in which they appear in data from the OAI interface of
                the DBT, with the date "2006-01-01".
                LDF 2006.07.06.  
*/

set @hyphen_index = patindex('%--%', @new_datestamp_str)
if @hyphen_index <> 0
   set @new_datestamp_str = '2006-01-01'

set @hyphen_index = patindex('%--%', @temp_dc_date_str)
if @hyphen_index <> 0
   set @temp_dc_date_str = '2006-01-01'


set @hyphen_index = patindex('%-%', @new_datestamp_str)
if @hyphen_index = 0
set @new_datestamp_str = @new_datestamp_str + '-01-01'

set @hyphen_index = patindex('%:%', @new_datestamp_str)
if @hyphen_index = 0
set @new_datestamp_str = @new_datestamp_str + 'T00:00:00.000'

set @hyphen_index = patindex('%-%', @temp_dc_date_str)
if @hyphen_index = 0
set @temp_dc_date_str = @temp_dc_date_str + '-01-01'

set @temp_dc_date_str = @temp_dc_date_str + 'T00:00:00.000'

select @new_datestamp_str as 'new_datestamp_str after'
select @temp_dc_date_str as 'temp_dc_date_str after'


set identity_insert Records on
insert records
(record_id, header_identifier, header_datestamp, header_status, dc_date)
values
(@record_ctr, @curr_header_id, 
 convert(datetime, @new_datestamp_str, 126),
 @status_str,
 convert(datetime, @temp_dc_date_str, 126))

set identity_insert Records off

select top 1 @curr_record_id = record_id from records order by record_id desc


/* ** (2) Handle `dc:creator' entries (possibly multiple).  */

select top 1 @temp_ctr = creator_id from Creators order by creator_id desc

if @temp_ctr is NULL
set @creator_ctr = 1
else
set @creator_ctr = @temp_ctr + 1

declare creator_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:creator') 
where text is not null

open creator_cursor

fetch next from creator_cursor
into 
@temp_dc_creator

set identity_insert Creators on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_creator' = @temp_dc_creator
 

select @curr_creator_id = creator_id from creators where dc_creator = @temp_dc_creator

if not exists (select creator_id from creators 
       where dc_creator = @temp_dc_creator) 
   begin
      insert creators
      (creator_id, dc_creator)
      values
      (@creator_ctr, @temp_dc_creator)
      set @curr_creator_id = @creator_ctr
      set @creator_ctr = @creator_ctr + 1
   end


if not exists (select * from records_creators where creator_id = @curr_creator_id 
               and record_id = @curr_record_id)
begin
insert records_creators
(record_id, creator_id)
values
(@curr_record_id, @curr_creator_id)
end

fetch next from creator_cursor
into 
@temp_dc_creator
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Creators off


close creator_cursor
deallocate creator_cursor

/* ** (2) Handle `dc:contributor' entries (possibly multiple).  */

select top 1 @temp_ctr = contributor_id from Contributors order by contributor_id desc

if @temp_ctr is NULL
set @contributor_ctr = 1
else
set @contributor_ctr = @temp_ctr + 1

declare contributor_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:contributor') 
where text is not null

open contributor_cursor

fetch next from contributor_cursor
into 
@temp_dc_contributor

set identity_insert Contributors on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_contributor' = @temp_dc_contributor
 

select @curr_contributor_id = contributor_id from contributors where dc_contributor = @temp_dc_contributor

if not exists (select contributor_id from contributors 
       where dc_contributor = @temp_dc_contributor) 
   begin
      insert contributors
      (contributor_id, dc_contributor)
      values
      (@contributor_ctr, @temp_dc_contributor)
      set @curr_contributor_id = @contributor_ctr
      set @contributor_ctr = @contributor_ctr + 1
   end


if not exists (select * from records_contributors where contributor_id = @curr_contributor_id 
               and record_id = @curr_record_id)
begin
insert records_contributors
(record_id, contributor_id)
values
(@curr_record_id, @curr_contributor_id)
end

fetch next from contributor_cursor
into 
@temp_dc_contributor
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Contributors off


close contributor_cursor
deallocate contributor_cursor

/* ** (2) Handle `dc:title' entries (possibly multiple).  */

select top 1 @temp_ctr = title_id from Titles order by title_id desc

if @temp_ctr is NULL
set @title_ctr = 1
else
set @title_ctr = @temp_ctr + 1

declare title_cursor cursor for
select convert(varchar(512), [text]), parentid
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:title') 
where text is not null

declare @title_id int
declare @curr_parent_id int

select @title_id = id
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:title') 
where localname = 'title'

select 'title_id' = @title_id 


-- Testing.  LDF 2006.07.06.

select * from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:title') 

/* End of testing.  LDF 2006.07.06.  */

open title_cursor

set identity_insert Titles on

fetch next from title_cursor
into 
@temp_dc_title, @curr_parent_id

while (@@fetch_status <> -1)
begin

select '@curr_parent_id' = @curr_parent_id

if @curr_parent_id = @title_id
and
not exists 
(select * from titles 
    where dc_title = @temp_dc_title
    and record_id = @curr_record_id)
begin
insert titles
(title_id, record_id, dc_title)
values
(@title_ctr, @curr_record_id, @temp_dc_title)
set @title_ctr = @title_ctr + 1
end
fetch next from title_cursor
into 
@temp_dc_title, @curr_parent_id
-- select '@@fetch_status' = @@fetch_status
end

set identity_insert Titles off

close title_cursor
deallocate title_cursor

/* ** (2) Handle `dc:subject' entries (possibly multiple).  */

select top 1 @temp_ctr = subject_id from Subjects order by subject_id desc

if @temp_ctr is NULL
set @subject_ctr = 1
else
set @subject_ctr = @temp_ctr + 1

declare subject_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:subject') 
where text is not null

open subject_cursor

fetch next from subject_cursor
into 
@temp_dc_subject

set identity_insert Subjects on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_subject' = @temp_dc_subject
 

select @curr_subject_id = subject_id from subjects where dc_subject = @temp_dc_subject

if not exists (select subject_id from subjects 
       where dc_subject = @temp_dc_subject) 
   begin
      insert subjects
      (subject_id, dc_subject)
      values
      (@subject_ctr, @temp_dc_subject)
      set @curr_subject_id = @subject_ctr
      set @subject_ctr = @subject_ctr + 1
   end


if not exists (select * from records_subjects where subject_id = @curr_subject_id 
               and record_id = @curr_record_id)
begin
insert records_subjects
(record_id, subject_id)
values
(@curr_record_id, @curr_subject_id)
end

fetch next from subject_cursor
into 
@temp_dc_subject
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Subjects off


close subject_cursor
deallocate subject_cursor

/* ** (2) Handle `dc:description' entries (possibly multiple).  */

select top 1 @temp_ctr = description_id from Descriptions order by description_id desc

if @temp_ctr is NULL
set @description_ctr = 1
else
set @description_ctr = @temp_ctr + 1

declare description_cursor cursor for
select convert(varchar(2048), [text]) 
   from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:description') 
where text is not null

open description_cursor

set identity_insert Descriptions on

fetch next from description_cursor
into 
@temp_dc_description
while (@@fetch_status <> -1)
begin
-- select '@temp_dc_description' = @temp_dc_description
if not exists (select * from descriptions where dc_description = @temp_dc_description)
begin
insert descriptions
(description_id, record_id, dc_description)
values
(@description_ctr, @curr_record_id, @temp_dc_description)
set @description_ctr = @description_ctr + 1
end
fetch next from description_cursor
into 
@temp_dc_description
-- select '@@fetch_status' = @@fetch_status
end

set identity_insert Descriptions off

close description_cursor
deallocate description_cursor

/* ** (2) Handle `dc:publisher' entries (possibly multiple).  */

select top 1 @temp_ctr = publisher_id from Publishers order by publisher_id desc

if @temp_ctr is NULL
set @publisher_ctr = 1
else
set @publisher_ctr = @temp_ctr + 1

declare publisher_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:publisher') 
where text is not null

open publisher_cursor

fetch next from publisher_cursor
into 
@temp_dc_publisher

set identity_insert Publishers on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_publisher' = @temp_dc_publisher
 

select @curr_publisher_id = publisher_id from publishers where dc_publisher = @temp_dc_publisher

if not exists (select publisher_id from publishers 
       where dc_publisher = @temp_dc_publisher) 
   begin
      insert publishers
      (publisher_id, dc_publisher)
      values
      (@publisher_ctr, @temp_dc_publisher)
      set @curr_publisher_id = @publisher_ctr
      set @publisher_ctr = @publisher_ctr + 1
   end


if not exists (select * from records_publishers where publisher_id = @curr_publisher_id 
               and record_id = @curr_record_id)
begin
insert records_publishers
(record_id, publisher_id)
values
(@curr_record_id, @curr_publisher_id)
end

fetch next from publisher_cursor
into 
@temp_dc_publisher
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Publishers off


close publisher_cursor
deallocate publisher_cursor


/* ** (2) Handle `dc:type' entries (possibly multiple).  */

select top 1 @temp_ctr = type_id from Types order by type_id desc

if @temp_ctr is NULL
set @type_ctr = 1
else
set @type_ctr = @temp_ctr + 1

declare type_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:type') 
where text is not null

open type_cursor

fetch next from type_cursor
into 
@temp_dc_type

set identity_insert Types on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_type' = @temp_dc_type
 

select @curr_type_id = type_id from types where dc_type = @temp_dc_type

if not exists (select type_id from types 
       where dc_type = @temp_dc_type) 
   begin
      insert types
      (type_id, dc_type)
      values
      (@type_ctr, @temp_dc_type)
      set @curr_type_id = @type_ctr
      set @type_ctr = @type_ctr + 1
   end


if not exists (select * from records_types where type_id = @curr_type_id 
               and record_id = @curr_record_id)
begin
insert records_types
(record_id, type_id)
values
(@curr_record_id, @curr_type_id)
end

fetch next from type_cursor
into 
@temp_dc_type
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Types off


close type_cursor
deallocate type_cursor


/* ** (2) Handle `dc:rights' entries (possibly multiple).  */

select top 1 @temp_ctr = rights_id from Rights order by rights_id desc

if @temp_ctr is NULL
set @rights_ctr = 1
else
set @rights_ctr = @temp_ctr + 1

declare rights_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:rights') 
where text is not null

open rights_cursor

fetch next from rights_cursor
into 
@temp_dc_rights

set identity_insert Rights on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_rights' = @temp_dc_rights
 

select @curr_rights_id = rights_id from rights where dc_rights = @temp_dc_rights

if not exists (select rights_id from rights 
       where dc_rights = @temp_dc_rights) 
   begin
      insert rights
      (rights_id, dc_rights)
      values
      (@rights_ctr, @temp_dc_rights)
      set @curr_rights_id = @rights_ctr
      set @rights_ctr = @rights_ctr + 1
   end


if not exists (select * from records_rights where rights_id = @curr_rights_id 
               and record_id = @curr_record_id)
begin
insert records_rights
(record_id, rights_id)
values
(@curr_record_id, @curr_rights_id)
end

fetch next from rights_cursor
into 
@temp_dc_rights
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Rights off


close rights_cursor
deallocate rights_cursor

/* ** (2) Handle `dc:language' entries (possibly multiple).  */

select top 1 @temp_ctr = language_id from Languages order by language_id desc

if @temp_ctr is NULL
set @language_ctr = 1
else
set @language_ctr = @temp_ctr + 1

declare language_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:language') 
where text is not null

open language_cursor

fetch next from language_cursor
into 
@temp_dc_language

set identity_insert Languages on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_language' = @temp_dc_language
 

select @curr_language_id = language_id from languages where dc_language = @temp_dc_language

if not exists (select language_id from languages 
       where dc_language = @temp_dc_language) 
   begin
      insert languages
      (language_id, dc_language)
      values
      (@language_ctr, @temp_dc_language)
      set @curr_language_id = @language_ctr
      set @language_ctr = @language_ctr + 1
   end


if not exists (select * from records_languages where language_id = @curr_language_id 
               and record_id = @curr_record_id)
begin
insert records_languages
(record_id, language_id)
values
(@curr_record_id, @curr_language_id)
end

fetch next from language_cursor
into 
@temp_dc_language
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Languages off


close language_cursor
deallocate language_cursor

/* ** (2) Handle `dc:identifier' entries (possibly multiple).  */

select top 1 @temp_ctr = identifier_id from Identifiers order by identifier_id desc

if @temp_ctr is NULL
set @identifier_ctr = 1
else
set @identifier_ctr = @temp_ctr + 1

declare identifier_cursor cursor for
select convert(varchar(512), [text]) 
from openxml(@testdoc, '/record/metadata/oai_dc:dc/dc:identifier') 
where text is not null

open identifier_cursor

fetch next from identifier_cursor
into 
@temp_dc_identifier

set identity_insert Identifiers on

while (@@fetch_status <> -1)
begin
-- select '@temp_dc_identifier' = @temp_dc_identifier
 

select @curr_identifier_id = identifier_id from identifiers where dc_identifier = @temp_dc_identifier

if not exists (select identifier_id from identifiers 
       where dc_identifier = @temp_dc_identifier) 
   begin
      insert identifiers
      (identifier_id, dc_identifier)
      values
      (@identifier_ctr, @temp_dc_identifier)
      set @curr_identifier_id = @identifier_ctr
      set @identifier_ctr = @identifier_ctr + 1
   end


if not exists (select * from records_identifiers where identifier_id = @curr_identifier_id 
               and record_id = @curr_record_id)
begin
insert records_identifiers
(record_id, identifier_id)
values
(@curr_record_id, @curr_identifier_id)
end

fetch next from identifier_cursor
into 
@temp_dc_identifier
-- select '@@fetch_status' = @@fetch_status

end

set identity_insert Identifiers off


close identifier_cursor
deallocate identifier_cursor



/* ** (2) Display tables.  */

/* 
select * from records

select * from creators
select * from records_creators

select * from titles

select * from contributors
select * from records_contributors

select * from descriptions

select * from publishers
select * from records_publishers

select * from types
select * from records_types

select * from rights
select * from records_rights

select * from languages
select * from records_languages

select * from subjects
select * from records_subjects
select * from records_subjects
select * from records_subjects

select * from identifiers
select * from records_identifiers
*/

go

/* * (1) End of `write_to_tables' procedure definition.  */

/* * (1) */

/* (outline-mode)  */

/* * (1) */

/* Local Variables: */
/* mode:Outline */
/* abbrev-mode:t */
/* End: */